> For the complete documentation index, see [llms.txt](https://uci.sunbird.org/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://uci.sunbird.org/use/developer/uci-basics/schema-overview/uci-core-schema/xmessage-schema.md).

# XMessage Schema

UCI saves all conversation data in form of XMessages. These XMessages follow a certain [specification](/use/developer/uci-basics/xmessage-specification.md). These XMessage will be saved in cassandra DB. Its object is defined in [dao repository](https://uci.sunbird.org/use/developer/uci-basics/schema-overview/uci-core-schema/pages/mN86WTnKfapEwuzEiaut#2.3.-dao).

## Schema

<table><thead><tr><th width="184.43902439024393">Field</th><th width="150">Type</th><th>Description</th></tr></thead><tbody><tr><td>id</td><td>uuid</td><td>unique identification</td></tr><tr><td>userId</td><td>text</td><td>to - phone of user/admin</td></tr><tr><td>fromId</td><td>text</td><td>from - phone of user/admin</td></tr><tr><td>channel</td><td>text</td><td>channel (Eg. Whatsapp/SMS)</td></tr><tr><td>provider</td><td>text</td><td>provider (Eg. Gupshup/Netcore)</td></tr><tr><td>timestamp</td><td>timestamp</td><td></td></tr><tr><td>messageState</td><td>text</td><td>state(Eg. Replied/Sent/Read)</td></tr><tr><td>xMessage</td><td>text</td><td>xMessage XML stringyfied</td></tr><tr><td>app</td><td>text</td><td>bot name</td></tr><tr><td>auxData</td><td>text</td><td>auxilary data</td></tr><tr><td>messageId</td><td>text</td><td>id of message from provider</td></tr><tr><td>replyId</td><td>text</td><td>id of user to reply to</td></tr><tr><td>causeId</td><td>text</td><td></td></tr><tr><td>sessionId</td><td>uuid</td><td>session id of conversation</td></tr><tr><td>ownerOrgId</td><td>text</td><td>owner org id of bot</td></tr><tr><td>ownerId</td><td>text</td><td>owner id</td></tr><tr><td>botUuid</td><td>uuid</td><td>bot uuid</td></tr></tbody></table>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://uci.sunbird.org/use/developer/uci-basics/schema-overview/uci-core-schema/xmessage-schema.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
